config/routes.rb
Rails.application.routes.draw do
	
	root	"links#index"
	resources :links
	
	get		"/about",				to:"static_pages#about"
	get		"/:short_url",	to:"links#redirect"

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/link.rb
class Link < ApplicationRecord
	
	# Initial defaults
	before_create do 
		self.count = 0
		self.short_url = Link.random_hash
	end

	# Use a custom validator to make sure this looks like a URL
	validates :url, presence: true, url: true

	# Use a 6-character hash encoded as Base-36.
	def Link.HASH_SEED_LENGTH
		6
	end

	def Link.random_hash
		the_hash = nil

		# It's unlikely we'd get a hash collision in the context of this demo app,
		# but just to make sure...
		while the_hash.nil? || Link.find_by(short_url: the_hash)
			the_hash = SecureRandom.random_number(36**Link.HASH_SEED_LENGTH).to_s(36)	
		end

		return the_hash
	end

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/links_controller.rb
class LinksController < ApplicationController
	
	def new
		@link = Link.new
	end

	def index
		@links = Link.all.order(created_at: :desc)
	end

	def create
		@link = Link.new(link_params)
		if @link.save
			flash[:success] = (render_to_string "_success_message", layout: false).html_safe
			redirect_to root_path
		else
			render 'new', status: :unprocessable_entity
		end
	end

	def destroy
		@link = Link.find(params[:id])
		@link.destroy
		redirect_to root_path
	end

	# This is the main logic of the redirect service. First, try to fetch the short url from the DB.
	# If it exists, redirect to the original link and increment the click counter.
	def redirect
		@link = Link.find_by(short_url: params[:short_url])
		if @link
			@link.count += 1
			@link.save
			redirect_to @link.url, allow_other_host: true
		else
			redirect_to root_path
		end
	end

	private
		def link_params
			params.require(:link).permit(:url)
		end

end

app/controllers/static_pages_controller.rb
class StaticPagesController < ApplicationController
  def home
  end

  def about
  end

  def contact
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
	def page_title(subtitle='')
		base_title = "Link-O-Matic"
		if subtitle.empty?
			base_title
		else
			"#{base_title} | #{subtitle}"
		end
	end

	def flash_sanitize(message)
		sanitize message, attributes: ["target", "href", "class", "data-clipboard-text"], 
								tags: ["div", "p", "a", "button", "i"] 
	end
end

app/helpers/links_helper.rb
module LinksHelper
	def absolute_short_url(link)
		port = request.port == 80 || request.port == 443 ? "" : ":#{request.port}"
		"#{request.scheme}://#{request.host}#{port}/#{link.short_url}"
	end
end

app/helpers/static_pages_helper.rb
module StaticPagesHelper
end

app/views/layouts/_footer.html.erb
<footer class="footer has-text-centered">
	<nav>
		<%= link_to "About", about_path, class: "is-uppercase mx-1 has-text-link-light has-text-weight-semibold"  %>
		<%= link_to "Contact", "mailto:lee.falin@gmail.com", class: "is-uppercase mx-1 has-text-link-light has-text-weight-semibold"  %>
	</nav>
	<p class="mt-3 has-text-grey-lighter">&copy; 2022 Lee Falin</p>
</footer>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
	<head>
		<title><%= page_title( yield(:title) ) %></title>
		<meta name="viewport" content="width=device-width,initial-scale=1">
		<%= csrf_meta_tags %>
		<%= csp_meta_tag %>

		<%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
		<%= stylesheet_link_tag "https://cdn.jsdelivr.net/npm/bulma@0.9.4/css/bulma.min.css" %>
		<%= javascript_include_tag "https://kit.fontawesome.com/b7eb7906f2.js" %>
		<%= javascript_importmap_tags %>
	</head>

	<body>
		<main>
			<section class="section">
				<div class="container is-max-desktop">
					<div class="has-text-centered">
						<h1 class="title is-size-1-tablet has-text-centered"><%= link_to "Link-O-Matic", root_path, class:"has-text-black" %></h1>
						<p class="subtitle"><%= yield(:title) %></p>
					</div>
					<div class="content mt-5 mb-0">
						<% flash.each do |message_type, message| %>
        					<div class="notification has-text-centered has-text-weight-semibold is-<%= message_type %>">
        						<%= flash_sanitize message%>
        					</div>
      					<% end %>
						<%= yield %>
					</div>
				</div>
			</section>
		</main>
		<%= render "layouts/footer" %>
	</body>
</html>

app/views/links/_cards.html.erb
<% @links.each do |l| %>
	<div class="block">
		<div class="card">
			<div class="card-content">
				<div class="media-content">
					<p class="title is-4"><%= link_to "Link: #{l.short_url}", absolute_short_url(l)  %></p>
					<p class="subtitle is-6"><%= l.count %> Clicks</p>
				</div>
				<p class="is-size-7 mt-3"><%= l.url %></p>
			</div>
			<footer class="card-footer">
				<a class="card-footer-item copy-button" data-clipboard-text="<%= absolute_short_url(l) %>">
					Copy <i class="fa-duotone fa-clipboard"></i></i>
				</a>
				<%= link_to "Delete", l, data: { "turbo-method": :delete }, 
										title: "Delete #{l.short_url}", class:"card-footer-item has-text-danger" %>
			</footer>
		</div>
	</div>
<% end %>

app/views/links/_full_form.html.erb
<%= form_with(model: @link) do |f| %>				
	<div class="field has-addons">
		<div class="control is-expanded">
			<%= f.text_field :url, class:"input", placeholder:"https://example.com/longurl?with_params=8675309" %>
		</div>
		<div class="control">
			<%= f.submit "Generate Link", class:"button is-info" %>
		</div>
	</div>
<% end %>

app/views/links/_mobile_form.html.erb
<%= form_with(model: @link) do |f| %>
	<div class="has-text-centered">
		<div class="field is-expanded">
			<%= f.text_field :url, class:'input', placeholder:"https://example.com/longurl?with_params=8675309" %>
		</div>
		<div class="control">
			<%= f.submit "Generate Link", class:'button is-info' %>
		</div>
	</div>
<% end %>

app/views/links/_success_message.html.erb
<div class='flash-message'>
	<p class="is-size-7-mobile">Link created succesfully: <%= link_to nil, absolute_short_url(@link), target: :_blank %></p>
	<button class="button is-small is-success is-light copy-button ml-3" 
			data-clipboard-text="<%= absolute_short_url(@link) %>">Copy <i class="fa-duotone fa-clipboard"></i>
	</button>
</div>

app/views/links/_table.html.erb
<table class="table links-table is-striped ">
	<thead>
		<tr><th class="has-text-left">Link-O-Matic Link</th><th class="has-text-left">Original URL</th>
			<th class="has-text-right">Clicks</th><th colspan="2">&nbsp;</th></tr>
	</thead>
	<tbody>
	<% @links.each do |l| %>
		<tr>
			<td><%= link_to absolute_short_url(l), absolute_short_url(l), data: { turbo:false }, target: :_blank %></td>
			<td><%= l.url %></td>
			<td class="has-text-right"><%= l.count %></td>
			<td class="has-text-centered">
				<button class="button is-small is-link is-outlined copy-button" data-clipboard-text="<%= absolute_short_url(l) %>">
					Copy <i class="fa-duotone fa-clipboard"></i>
				</button>
			</td>
			<td class="has-text-centered">
				<%= link_to(l, data: { "turbo-method": :delete }, title: "Delete #{l.short_url}") do %>
					<span class="icon has-text-danger">
						<i class="fa-duotone fa-trash-xmark"></i>
					</span>
				<% end %>
			</td>
		</tr>
	<% end %>
	</tbody>
</table>

app/views/links/index.html.erb
<% provide(:title, "A URL Shortener built with Ruby on Rails") %>
<section class="section" >

	<div class="mb-5 has-text-centered-mobile has-text-right-tablet">
		<%= link_to(new_link_path, class:"button is-info") do %>
			<span class="icon">
				<i class="fas fa-plus"></i>
			</span>
			<span>Create New Link</span>
		<% end %>
	</div>

	<!-- Tablets and larger table -->
	<div class="is-hidden-mobile">
		<%= render "table" %>
	</div>

	<!-- Mobile table -->
	<div class="is-hidden-tablet">
		<%= render "cards" %>
	</div>

</section>

app/views/links/new.html.erb
<% provide(:title, "Create a Link") %>

<section class="section">
	<p class="has-text-centered-mobile">Enter a URL to create a<br class="is-hidden-tablet"/> Link-O-Matic link.</p>
	<div>
		<%= render "shared/error_messages" %>
		<div class="is-hidden-mobile">
			<%= render "full_form" %>
		</div>

		<div class="is-hidden-tablet">
			<%= render "mobile_form" %>
		</div>
	</div>
</section>

app/views/shared/_error_messages.html.erb
<% if @link.errors.any? %>
	<article class="message is-danger">
		<div class="message-body">
		<% @link.errors.full_messages.each do |msg| %>
			<p><%= msg %></p>
		<% end %>
		</div>
	</article>
<% end %>

app/views/static_pages/about.html.erb
<% provide(:title, "A URL Shortener built with Ruby on Rails") %>

<section class="section" >
<h1>About This Site</h1>

<p>Link-O-Matic is a URL-shortening service that tracks how often generated links have been clicked.</p>

<p>This service is hosted on <a href="https://heroku.com">Heroku</a> and was built using the following:</p>
<ul>
	<li><a href="https://rubyonrails.org">Ruby on Rails</a></li>
	<li><a href="https://developer.mozilla.org/en-US/docs/Learn/JavaScript">Vanilla JavaScript</a></li>
	<li><a href="https://bulma.io">The Bulma CSS Framework</a></li>
	<li><a href="https://fontawesome.com">FontAwesome 6</a></li>
	<li><a href="https://www.postgresql.org">Postgres</a></li>
</ul>
</section>